> ## Documentation Index
> Fetch the complete documentation index at: https://developer.watson-orchestrate.ibm.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Register Watsonx Assistant Instance

<Note>
  If only one of the fields [**name**](#body-name) or [**nickname**](#body-nickname) is provided, the system automatically generates the other based on the value you entered.
</Note>


## OpenAPI

````yaml post /v1/assistants/watsonx
openapi: 3.1.0
info:
  title: WxO Server API
  summary: API for the next gen watsonx Orchestrate stack
  description: >+

    The watsonx Orchestrate Server provides a set of APIs to power the watsonx
    Orchestrate AI assistant. This includes the following core services:


    * Orchestrate Assistant - a built-in AI assistant that powers the
    Orchestrate end-user experience.

    * Custom Assistants - a service layer for interacting with existing AI
    assistatns (such as those in watsonx Assistant).

    * Message Threads - a chat history and async message tracking store.

    * Document Store - manage collections of documents in nearly any format
    including text, pdf, html and many more.

    * Information Extraction - automatically extract clean text and images from
    any document in the Document Store.  Also extract other useful metadata like
    questions answered, keywords, and named entities.

    * Embedding - generate vector embeddings for text and images in the Document
    Store.

    * Vector Index and Retrieval - automatically index documents with rich
    metadata for vector search or hybrid search.

    * Search Engine - create a Gen AI powered search engine that works like Bing
    or Google.

    * Query Engine - configure your own RAG (Retrieval Augmented Generation)
    engine supporting advanced retrieval patterns and automated data management.

    * Model Proxy - create your own LLM model endpoints for chat completions and
    embeddings.  Supports IBM watsonx.ai, IBM BAM, OpenAI, MistralAI, or Ollama
    for local models.


    WxO API Server utilizes the following open source projects:


    * [PostgreSQL](https://www.postgresql.org/)

    * [PGVector](https://github.com/pgvector/pgvector)

    * [LlamaIndex](https://docs.llamaindex.ai/en/stable/)

    * [LangChain](https://python.langchain.com/docs/get_started/introduction)

    * [FastAPI](https://fastapi.tiangolo.com/)

    * [Unstructured](https://unstructured.io/)

    * [Celery](https://docs.celeryproject.org/en/stable/)

  version: 0.1.0
servers:
  - url: https://{api_endpoint}
    description: version
security: []
paths:
  /v1/assistants/watsonx:
    post:
      tags:
        - watsonx Assistant
      summary: Register Watsonx Assistant Instance
      operationId: Register_watsonx_Assistant_Instance_v1_assistants_watsonx_post
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/RegisterWatsonAssistant'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema: {}
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    RegisterWatsonAssistant:
      properties:
        title:
          anyOf:
            - type: string
            - type: 'null'
          title: Title
        description:
          type: string
          title: Description
        tags:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Tags
        name:
          anyOf:
            - type: string
            - type: 'null'
          title: Name
        nickname:
          anyOf:
            - type: string
            - type: 'null'
          title: Nickname
        config:
          $ref: '#/components/schemas/WatsonAssistantConfigRequest'
      type: object
      required:
        - description
        - config
      title: RegisterWatsonAssistant
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    WatsonAssistantConfigRequest:
      properties:
        assistant_id:
          type: string
          title: Assistant Id
        environment_id:
          type: string
          title: Environment Id
        intent:
          anyOf:
            - type: string
            - type: 'null'
          title: Intent
        action_title:
          anyOf:
            - type: string
            - type: 'null'
          title: Action Title
        search_stickiness:
          type: boolean
          title: Search Stickiness
          default: false
        shareable_context:
          type: boolean
          title: Shareable Context
          default: true
        hidden:
          type: boolean
          title: Hidden
          default: false
        api_key:
          anyOf:
            - type: string
            - type: 'null'
          title: Api Key
        service_instance_url:
          type: string
          title: Service Instance Url
        api_version:
          type: string
          title: Api Version
          default: '2023-06-15'
        auth_type:
          $ref: '#/components/schemas/WatsonAssistantAuthTypeRequest'
          default: BEARER_TOKEN
        auth_config:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Auth Config
        authorization_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Authorization Url
        crn:
          anyOf:
            - type: string
            - type: 'null'
          title: Crn
        message_context:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Message Context
        connection_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Connection Id
        context_access_enabled:
          type: boolean
          title: Context Access Enabled
          description: Enable access to context variables for this agent
          default: true
        context_variables:
          items:
            type: string
          type: array
          title: Context Variables
          description: List of context variable names that this agent can access
          default: []
      type: object
      required:
        - assistant_id
        - environment_id
        - service_instance_url
      title: WatsonAssistantConfigRequest
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    WatsonAssistantAuthTypeRequest:
      type: string
      enum:
        - ICP_IAM
        - IBM_CLOUD_IAM
        - MCSP
        - BEARER_TOKEN
      title: WatsonAssistantAuthTypeRequest
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````